	// verilator_coverage annotation
	// generated by verigenSV.pl on Tue Jun  8 10:39:16 2021
	// input file: cache.cfg
	
	// compiler directives
	/* verilator lint_off CASEINCOMPLETE */
	/* verilator lint_off DECLFILENAME */
	/* verilator lint_off UNUSED */
	/* verilator lint_off STMTDLY */
	/* verilator lint_off UNOPTFLAT */
	
	
	module CACHE (
 000251		input logic clk,
%000002		input logic res_n,
%000002		input logic lock,
%000004		input logic unlock,
%000078		input logic [KEY_WIDTH-1:0] key,
%000260		input logic [PHYS_ADDR_WIDTH-1:0] phys_addr_in,
%000007		input logic phys_addr_in_vld,
%000160		input logic [BLOCK_SIZE-1:0] data_from_mem,
%000004		input logic data_from_mem_vld,
%000058		input logic [BLOCK_SIZE-1:0] data_from_cpu,
%000002		input logic data_from_cpu_vld,
%000232		output logic [BLOCK_SIZE-1:0] data_to_cpu, 
%000006		output logic data_to_cpu_vld, 
%000229		output logic [BLOCK_SIZE-1:0] data_to_victim_buffer, 
%000006		output logic data_to_victim_buffer_vld, 
%000004		output logic miss, 
%000001		output logic locked );
	
	  //
	 // parameter constants 
	//---------------------------
	parameter int CACHE_SIZE = 256;
	parameter int PHYS_ADDR_WIDTH = 40;
	parameter int INDEX_WIDTH = 9;
	parameter int OFFSET_WIDTH = 6;
	parameter int KEY_WIDTH = 32; ;
	parameter logic [KEY_WIDTH-1:0] KEY = {KEY_WIDTH{1'b1}};
	
	
	  //
	 // state encoding typedef 
	//--------------------------------
	typedef enum logic [3:0] {
		LOCKED = 4'b1111,
		IDLE = 4'b0000,
		RD_REQ = 4'b1000,
		RD_REQ_MISS = 4'b1011,
		RD_REQ_HIT_B0 = 4'b1001,
		RD_REQ_HIT_B1 = 4'b1010,
		WR_REQ = 4'b0100,
		WR_REQ_MISS = 4'b0111,
		WR_REQ_HIT_B0 = 4'b0101,
		WR_REQ_HIT_B1 = 4'b0110
	} states_t;
	
	
	// internal state variables
%000023	states_t STATE, NEXT_STATE;
%000023	verilator_coverage: (next point on previous line)

	
	  //
	 // memory instantiations 
	//---------------------------
	RAM #( BLOCK_SIZE, BLOCK_NUM ) B0_DAT_RAM(
		.clk(clk), .res_n(res_n), 
		.wr(B0_DAT_RAM_wr), .wr_addr(B0_DAT_RAM_wr_addr[INDEX_WIDTH-1:0]), .wr_data(B0_DAT_RAM_wr_data[BLOCK_SIZE-1:0]), 
		.rd(B0_DAT_RAM_rd), .rd_addr(B0_DAT_RAM_rd_addr[INDEX_WIDTH-1:0]), .rd_data(B0_DAT_RAM_rd_data[BLOCK_SIZE-1:0]) );
	
	RAM #( TAG_WIDTH+1, BLOCK_NUM ) B0_TAG_RAM(
		.clk(clk), .res_n(res_n), 
		.wr(B0_TAG_RAM_wr), .wr_addr(B0_TAG_RAM_wr_addr[INDEX_WIDTH-1:0]), .wr_data(B0_TAG_RAM_wr_data[TAG_WIDTH+1-1:0]), 
		.rd(B0_TAG_RAM_rd), .rd_addr(B0_DAT_RAM_rd_addr[INDEX_WIDTH-1:0]), .rd_data(B0_TAG_RAM_rd_data[TAG_WIDTH+1-1:0]) );
	
	RAM #( BLOCK_SIZE, BLOCK_NUM ) B1_DAT_RAM(
		.clk(clk), .res_n(res_n), 
		.wr(B1_DAT_RAM_wr), .wr_addr(B1_DAT_RAM_wr_addr[INDEX_WIDTH-1:0]), .wr_data(B1_DAT_RAM_wr_data[BLOCK_SIZE-1:0]), 
		.rd(B1_DAT_RAM_rd), .rd_addr(B1_DAT_RAM_rd_addr[INDEX_WIDTH-1:0]), .rd_data(B1_DAT_RAM_rd_data[BLOCK_SIZE-1:0]) );
	
	RAM #( TAG_WIDTH+1, BLOCK_NUM ) B1_TAG_RAM(
		.clk(clk), .res_n(res_n), 
		.wr(B1_TAG_RAM_wr), .wr_addr(B1_TAG_RAM_wr_addr[INDEX_WIDTH-1:0]), .wr_data(B1_TAG_RAM_wr_data[TAG_WIDTH+1-1:0]), 
		.rd(B1_TAG_RAM_rd), .rd_addr(B1_TAG_RAM_rd_addr[INDEX_WIDTH-1:0]), .rd_data(B1_TAG_RAM_rd_data[TAG_WIDTH+1-1:0]) );
	
	   //
	  // user-defined SystemVerilog support code 
	 // (derived from <support> section) 
	//----------------------------------
	localparam logic ZERO = 1'b0;
	localparam logic ONE = 1'b1;
	localparam int TAG_WIDTH = PHYS_ADDR_WIDTH-INDEX_WIDTH-OFFSET_WIDTH;
	localparam int BLOCK_SIZE = int'($pow(2,OFFSET_WIDTH));
	localparam int BLOCK_NUM = int'($pow(2,INDEX_WIDTH));
	localparam logic [BLOCK_SIZE-1:0] ZERO_BLOCK = '0;
	localparam logic [TAG_WIDTH-1:0] ZERO_TAG = '0;
%000000	logic  b0_tag_vld;
%000013	logic [TAG_WIDTH-1:0] b0_tag;
%000005	logic  b1_tag_vld;
%000115	logic [TAG_WIDTH-1:0] b1_tag;
%000031	logic [BLOCK_SIZE-1:0] b0_dat;
%000236	logic [BLOCK_SIZE-1:0] b1_dat;
	
	   //
	  // implicit continuous assignments 
	 // (derived from <expressions> section) 
	//----------------------------------
	assign data_to_victim_buffer = data_to_cpu;
	assign data_to_victim_buffer_vld = data_to_cpu_vld;
	assign locked = ( STATE == LOCKED );
%000007	uwire DO_ABORT; assign DO_ABORT = !(IS_RD_REQ | IS_WR_REQ);
%000008	uwire DO_IDLE_RD; assign DO_IDLE_RD = !res_n | !phys_addr_in_vld;
%000002	uwire DO_IDLE_WR; assign DO_IDLE_WR = DO_IDLE_RD | !data_from_cpu_vld;
%000002	uwire DO_LOCK; assign DO_LOCK = !res_n | lock;
%000007	uwire DO_MEM_REQ; assign DO_MEM_REQ = phys_addr_in_vld & !data_from_mem_vld;
%000002	uwire DO_UNLOCK; assign DO_UNLOCK = res_n & unlock & IS_KEY_MATCH;
%000000	uwire IS_HIT_B0; assign IS_HIT_B0 = b0_tag_vld && (phys_addr_in[PHYS_ADDR_WIDTH-1:OFFSET_WIDTH+INDEX_WIDTH]==b0_tag);
%000004	uwire IS_HIT_B1; assign IS_HIT_B1 = b1_tag_vld && (phys_addr_in[PHYS_ADDR_WIDTH-1:OFFSET_WIDTH+INDEX_WIDTH]==b1_tag);
%000002	uwire IS_KEY_MATCH; assign IS_KEY_MATCH = (KEY==key);
%000004	uwire IS_MEM_REQ_DONE; assign IS_MEM_REQ_DONE = phys_addr_in_vld & data_from_mem_vld;
%000006	uwire IS_RD_REQ; assign IS_RD_REQ = IS_REQ & !data_from_cpu_vld;
%000007	uwire IS_REQ; assign IS_REQ = phys_addr_in_vld;
%000001	uwire IS_WR_REQ; assign IS_WR_REQ = IS_REQ &  data_from_cpu_vld;
%000049	uwire [INDEX_WIDTH-1:0] index; assign index = phys_addr_in[INDEX_WIDTH-1+OFFSET_WIDTH:OFFSET_WIDTH];
%000045	uwire [OFFSET_WIDTH-1:0] offset; assign offset = phys_addr_in[OFFSET_WIDTH-1:0];
%000166	uwire [TAG_WIDTH-1:0] tag; assign tag = phys_addr_in[PHYS_ADDR_WIDTH-1:OFFSET_WIDTH+INDEX_WIDTH];
	
	  //
	 // initials for simulator
	//---------------------------
%000002	initial begin
%000001	  STATE = LOCKED;
%000001	  b0_tag = '0;
%000001	  b0_tag_vld = 1'b0;
%000001	  b1_tag = '0;
%000001	  b1_tag_vld = 1'b0;
%000001	  b0_dat = '0;
%000001	  b1_dat = '0;
	
	  // dump output (Verilator)
%000002	  if ($test$plusargs("trace") != 0) begin
%000000	  verilator_coverage: (next point on previous line)

%000001	    $display("[%0t] Tracing to logs/vlt_dump.vcd...\n", $time);
%000001	    $dumpfile("logs/vlt_dump.vcd");
%000001	    $dumpvars();
	  end
%000001	  $display("[%0t] Model running...\n", $time);
	
	end
	
	  //
	 // state transfer
	//---------------------------
 000250	always_ff @( posedge clk ) begin
 000246	  if( res_n )
%000002	  verilator_coverage: (next point on previous line)

 000123	    STATE <= NEXT_STATE;
	  else
%000002	    STATE <= LOCKED;
	
	  // condition for $finish (Verilator)
%000002	  if( lock==1'b1 && unlock==1'b1 ) begin
 000124	  verilator_coverage: (next point on previous line)

%000001	    $write("*-* All Finished *-*\n");
%000001	    $finish;
	  end   
	
	end
	
	// AssertionExample:
	//always_ff @ (posedge clk) begin
	//   AssertionExample: assert (rd==1'b1 ^ wr==1'b1);
	//end
	
	// coverage analysis (Verilator)
 000100	cover property (@(posedge clk) phys_addr_in_vld==1'b1);
	
 000534	always_comb begin
	
	    //
	   // pre-case (default) assignments 
	  //----------------------------------
 000267	  b0_tag = ZERO_TAG;
 000267	  b0_tag_vld = 1'b0;
 000267	  b1_tag = ZERO_TAG;
 000267	  b1_tag_vld = 1'b0;
 000267	  data_to_cpu = ZERO_BLOCK;
 000267	  data_to_cpu_vld = 1'b0;
 000267	  miss = 1'b0;
 000267	  NOP_B0_DAT_RAM();
 000267	  NOP_B0_TAG_RAM();
 000267	  NOP_B1_DAT_RAM();
 000267	  NOP_B1_TAG_RAM();
	
 000267	  unique case ( STATE )
 000028	  LOCKED : begin
 000026		if ( !DO_UNLOCK ) begin
%000001		verilator_coverage: (next point on previous line)

 000013		  NEXT_STATE = LOCKED;
		end
%000002		if ( DO_UNLOCK ) begin
 000013		verilator_coverage: (next point on previous line)

%000001		  NEXT_STATE = IDLE;
		end
%000018		if ( DO_LOCK ) begin
%000005		verilator_coverage: (next point on previous line)

%000009		  NEXT_STATE = LOCKED;
		end  end // LOCKED
 000292	  IDLE : begin
%000000		if ( DO_LOCK ) begin
 000146		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = LOCKED;
		end
%000010		if ( IS_RD_REQ ) begin
 000141		verilator_coverage: (next point on previous line)

%000005		  NEXT_STATE = RD_REQ;
%000005		  {b0_tag_vld,b0_tag} = POP_B0_TAG_RAM(phys_addr_in_vld,index);
%000005		  {b1_tag_vld,b1_tag} = POP_B1_TAG_RAM(phys_addr_in_vld,index);
		end
%000006		if ( IS_WR_REQ ) begin
 000143		verilator_coverage: (next point on previous line)

%000003		  NEXT_STATE = WR_REQ;
%000003		  {b0_tag_vld,b0_tag} = POP_B0_TAG_RAM(phys_addr_in_vld,index);
%000003		  {b1_tag_vld,b1_tag} = POP_B1_TAG_RAM(phys_addr_in_vld,index);
		end
 000276		if ( !IS_REQ ) begin
%000008		verilator_coverage: (next point on previous line)

 000138		  NEXT_STATE = IDLE;
		end  end // IDLE
%000014	  RD_REQ : begin
%000000		if ( DO_LOCK ) begin
%000007		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = LOCKED;
		end
%000000		if ( IS_HIT_B0 ) begin
%000007		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = RD_REQ_HIT_B0;
%000000		  {b0_tag_vld,b0_tag} = POP_B0_TAG_RAM(phys_addr_in_vld,index);
%000000		  b0_dat = POP_B0_DAT_RAM(phys_addr_in_vld,index);
		end
%000006		if ( IS_HIT_B1 & !IS_HIT_B0 ) begin
%000004		verilator_coverage: (next point on previous line)

%000003		  NEXT_STATE = RD_REQ_HIT_B1;
%000003		  {b1_tag_vld,b1_tag} = POP_B1_TAG_RAM(phys_addr_in_vld,index);
%000003		  b1_dat = POP_B1_DAT_RAM(phys_addr_in_vld,index);
		end
%000008		if ( !(IS_HIT_B0 | IS_HIT_B1) ) begin
%000003		verilator_coverage: (next point on previous line)

%000004		  NEXT_STATE = RD_REQ_MISS;
%000004		  miss=1'b1;
		end
%000000		if ( DO_IDLE_RD ) begin
%000007		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = IDLE;
		end  end // RD_REQ
 000072	  RD_REQ_MISS : begin
%000000		if ( DO_LOCK ) begin
 000036		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = LOCKED;
		end
%000000		if ( DO_LOCK ) begin
 000036		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = LOCKED;
		end
%000000		if ( DO_IDLE_RD ) begin
 000036		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = IDLE;
		end
 000068		if ( DO_MEM_REQ ) begin
%000002		verilator_coverage: (next point on previous line)

 000034		  NEXT_STATE = RD_REQ_MISS;
 000034		  miss=1'b1;
		end
%000000		if ( IS_MEM_REQ_DONE & !phys_addr_in[0] ) begin
 000036		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = RD_REQ_HIT_B0;
%000000		  PUSH_B0_DAT_RAM(phys_addr_in_vld & data_from_mem_vld,index,data_from_mem);
%000000		  PUSH_B0_TAG_RAM(phys_addr_in_vld,index,{1'b1,tag});
		end
%000004		if ( IS_MEM_REQ_DONE &  phys_addr_in[0] ) begin
 000034		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = RD_REQ_HIT_B1;
%000002		  PUSH_B1_DAT_RAM(phys_addr_in_vld & data_from_mem_vld,index,data_from_mem);
%000002		  PUSH_B1_TAG_RAM(phys_addr_in_vld,index,{1'b1,tag});
		end  end // RD_REQ_MISS
%000000	  RD_REQ_HIT_B0 : begin
%000000		if ( DO_LOCK ) begin
%000000		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = LOCKED;
		end
%000000		if ( phys_addr_in_vld ) begin
%000000		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = RD_REQ_HIT_B0;
%000000		  b0_dat = POP_B0_DAT_RAM(phys_addr_in_vld,index);
%000000		  data_to_cpu=b0_dat;
%000000		  data_to_cpu_vld=1'b1;
		end
%000000		if ( DO_IDLE_RD ) begin
%000000		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = IDLE;
		end  end // RD_REQ_HIT_B0
 000024	  RD_REQ_HIT_B1 : begin
%000000		if ( DO_LOCK ) begin
 000012		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = LOCKED;
		end
%000012		if ( phys_addr_in_vld ) begin
%000006		verilator_coverage: (next point on previous line)

%000006		  NEXT_STATE = RD_REQ_HIT_B1;
%000006		  b1_dat = POP_B1_DAT_RAM(phys_addr_in_vld,index);
%000006		  data_to_cpu=b1_dat;
%000006		  data_to_cpu_vld=1'b1;
		end
%000012		if ( DO_IDLE_RD ) begin
%000006		verilator_coverage: (next point on previous line)

%000006		  NEXT_STATE = IDLE;
		end  end // RD_REQ_HIT_B1
%000004	  WR_REQ : begin
%000000		if ( DO_LOCK ) begin
%000002		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = LOCKED;
		end
%000000		if ( IS_HIT_B0 ) begin
%000002		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = WR_REQ_HIT_B0;
%000000		  {b0_tag_vld,b0_tag} = POP_B0_TAG_RAM(phys_addr_in_vld,index);
%000000		  PUSH_B0_DAT_RAM(phys_addr_in_vld & data_from_cpu_vld,index,data_from_cpu);
		end
%000004		if ( IS_HIT_B1 & !IS_HIT_B0 ) begin
%000000		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = WR_REQ_HIT_B1;
%000002		  {b1_tag_vld,b1_tag} = POP_B1_TAG_RAM(phys_addr_in_vld,index);
%000002		  PUSH_B1_DAT_RAM(phys_addr_in_vld & data_from_cpu_vld,index,data_from_cpu);
		end
%000000		if ( !(IS_HIT_B0 | IS_HIT_B1) & !phys_addr_in[0] ) begin
%000002		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = WR_REQ_MISS;
%000000		  PUSH_B0_DAT_RAM(phys_addr_in_vld & data_from_cpu_vld,index,data_from_cpu);
		end
%000000		if ( !(IS_HIT_B0 | IS_HIT_B1) &  phys_addr_in[0] ) begin
%000002		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = WR_REQ_MISS;
%000000		  PUSH_B1_DAT_RAM(phys_addr_in_vld & data_from_cpu_vld,index,data_from_cpu);
		end
%000000		if ( DO_IDLE_WR ) begin
%000002		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = IDLE;
		end  end // WR_REQ
%000000	  WR_REQ_MISS : begin
%000000		if ( DO_LOCK ) begin
%000000		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = LOCKED;
		end
%000000		if ( phys_addr_in_vld & data_from_cpu_vld ) begin
%000000		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = WR_REQ_MISS;
		end
%000000		if ( DO_IDLE_WR ) begin
%000000		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = IDLE;
		end  end // WR_REQ_MISS
%000000	  WR_REQ_HIT_B0 : begin
%000000		if ( DO_LOCK ) begin
%000000		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = LOCKED;
		end
%000000		if ( phys_addr_in_vld & data_from_cpu_vld ) begin
%000000		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = WR_REQ_HIT_B0;
%000000		  b0_dat = POP_B0_DAT_RAM(phys_addr_in_vld,index);
%000000		  data_to_cpu=b0_dat;
		end
%000000		if ( DO_IDLE_WR ) begin
%000000		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = IDLE;
		end  end // WR_REQ_HIT_B0
 000100	  WR_REQ_HIT_B1 : begin
%000004		if ( DO_LOCK ) begin
 000048		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = LOCKED;
		end
 000100		if ( phys_addr_in_vld & data_from_cpu_vld ) begin
%000000		verilator_coverage: (next point on previous line)

 000050		  NEXT_STATE = WR_REQ_HIT_B1;
 000050		  b1_dat = POP_B1_DAT_RAM(phys_addr_in_vld,index);
 000050		  data_to_cpu=b1_dat;
		end
%000000		if ( DO_IDLE_WR ) begin
 000050		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = IDLE;
		end  end // WR_REQ_HIT_B1
	  endcase
	end // always_comb
	
	
	  //
	 // memory functions
	//---------------------------
%000001	logic B0_DAT_RAM_rd;
%000058	logic [BLOCK_SIZE-1:0] B0_DAT_RAM_rd_data;
%000004	logic [$clog2(BLOCK_NUM)-1:0] B0_DAT_RAM_rd_addr;
	
%000000	function automatic [BLOCK_SIZE-1:0] POP_B0_DAT_RAM( read, [$clog2(BLOCK_NUM)-1:0] read_addr);
%000000	   B0_DAT_RAM_rd = read;
%000000	   B0_DAT_RAM_rd_addr = read_addr;
%000000	   return B0_DAT_RAM_rd_data;
	endfunction
	
%000000	logic B0_DAT_RAM_wr;
%000029	logic [BLOCK_SIZE-1:0] B0_DAT_RAM_wr_data;
%000006	logic [$clog2(BLOCK_NUM)-1:0] B0_DAT_RAM_wr_addr;
	
%000000	function automatic void PUSH_B0_DAT_RAM( write, [$clog2(BLOCK_NUM)-1:0] write_addr, [BLOCK_SIZE-1:0] write_data);
%000000	   B0_DAT_RAM_wr = write;
%000000	   B0_DAT_RAM_wr_addr = write_addr;
%000000	   B0_DAT_RAM_wr_data = write_data;
	endfunction
	
 000534	function automatic void NOP_B0_DAT_RAM();
 000267	   B0_DAT_RAM_rd = 0;
 000267	   B0_DAT_RAM_wr = 0;
 000267	   B0_DAT_RAM_wr_addr = '0;
 000267	   B0_DAT_RAM_wr_data = '0;
 000267	   B0_DAT_RAM_rd_addr = '0;
	endfunction
	
%000009	logic B0_TAG_RAM_rd;
%000026	logic [TAG_WIDTH+1-1:0] B0_TAG_RAM_rd_data;
%000057	logic [$clog2(BLOCK_NUM)-1:0] B0_TAG_RAM_rd_addr;
	
 000032	function automatic [TAG_WIDTH+1-1:0] POP_B0_TAG_RAM( read, [$clog2(BLOCK_NUM)-1:0] read_addr);
 000016	   B0_TAG_RAM_rd = read;
 000016	   B0_TAG_RAM_rd_addr = read_addr;
 000016	   return B0_TAG_RAM_rd_data;
	endfunction
	
%000001	logic B0_TAG_RAM_wr;
%000013	logic [TAG_WIDTH+1-1:0] B0_TAG_RAM_wr_data;
%000005	logic [$clog2(BLOCK_NUM)-1:0] B0_TAG_RAM_wr_addr;
	
%000000	function automatic void PUSH_B0_TAG_RAM( write, [$clog2(BLOCK_NUM)-1:0] write_addr, [TAG_WIDTH+1-1:0] write_data);
%000000	   B0_TAG_RAM_wr = write;
%000000	   B0_TAG_RAM_wr_addr = write_addr;
%000000	   B0_TAG_RAM_wr_data = write_data;
	endfunction
	
 000534	function automatic void NOP_B0_TAG_RAM();
 000267	   B0_TAG_RAM_rd = 0;
 000267	   B0_TAG_RAM_wr = 0;
 000267	   B0_TAG_RAM_wr_addr = '0;
 000267	   B0_TAG_RAM_wr_data = '0;
 000267	   B0_TAG_RAM_rd_addr = '0;
	endfunction
	
%000007	logic B1_DAT_RAM_rd;
%000262	logic [BLOCK_SIZE-1:0] B1_DAT_RAM_rd_data;
%000049	logic [$clog2(BLOCK_NUM)-1:0] B1_DAT_RAM_rd_addr;
	
 000118	function automatic [BLOCK_SIZE-1:0] POP_B1_DAT_RAM( read, [$clog2(BLOCK_NUM)-1:0] read_addr);
 000059	   B1_DAT_RAM_rd = read;
 000059	   B1_DAT_RAM_rd_addr = read_addr;
 000059	   return B1_DAT_RAM_rd_data;
	endfunction
	
%000006	logic B1_DAT_RAM_wr;
%000181	logic [BLOCK_SIZE-1:0] B1_DAT_RAM_wr_data;
%000037	logic [$clog2(BLOCK_NUM)-1:0] B1_DAT_RAM_wr_addr;
	
%000008	function automatic void PUSH_B1_DAT_RAM( write, [$clog2(BLOCK_NUM)-1:0] write_addr, [BLOCK_SIZE-1:0] write_data);
%000004	   B1_DAT_RAM_wr = write;
%000004	   B1_DAT_RAM_wr_addr = write_addr;
%000004	   B1_DAT_RAM_wr_data = write_data;
	endfunction
	
 000534	function automatic void NOP_B1_DAT_RAM();
 000267	   B1_DAT_RAM_rd = 0;
 000267	   B1_DAT_RAM_wr = 0;
 000267	   B1_DAT_RAM_wr_addr = '0;
 000267	   B1_DAT_RAM_wr_data = '0;
 000267	   B1_DAT_RAM_rd_addr = '0;
	endfunction
	
%000008	logic B1_TAG_RAM_rd;
%000127	logic [TAG_WIDTH+1-1:0] B1_TAG_RAM_rd_data;
%000058	logic [$clog2(BLOCK_NUM)-1:0] B1_TAG_RAM_rd_addr;
	
 000052	function automatic [TAG_WIDTH+1-1:0] POP_B1_TAG_RAM( read, [$clog2(BLOCK_NUM)-1:0] read_addr);
 000026	   B1_TAG_RAM_rd = read;
 000026	   B1_TAG_RAM_rd_addr = read_addr;
 000026	   return B1_TAG_RAM_rd_data;
	endfunction
	
%000005	logic B1_TAG_RAM_wr;
%000096	logic [TAG_WIDTH+1-1:0] B1_TAG_RAM_wr_data;
%000020	logic [$clog2(BLOCK_NUM)-1:0] B1_TAG_RAM_wr_addr;
	
%000004	function automatic void PUSH_B1_TAG_RAM( write, [$clog2(BLOCK_NUM)-1:0] write_addr, [TAG_WIDTH+1-1:0] write_data);
%000002	   B1_TAG_RAM_wr = write;
%000002	   B1_TAG_RAM_wr_addr = write_addr;
%000002	   B1_TAG_RAM_wr_data = write_data;
	endfunction
	
 000534	function automatic void NOP_B1_TAG_RAM();
 000267	   B1_TAG_RAM_rd = 0;
 000267	   B1_TAG_RAM_wr = 0;
 000267	   B1_TAG_RAM_wr_addr = '0;
 000267	   B1_TAG_RAM_wr_data = '0;
 000267	   B1_TAG_RAM_rd_addr = '0;
	endfunction
	
	endmodule
	
	
	  //
	 // memory
	//---------------------------
	module RAM ( clk, res_n, wr, wr_addr, wr_data, rd, rd_addr, rd_data );
	
	parameter DATA_WIDTH = 32;
	parameter NUM_ENTRIES = 16;
	parameter ADDR_WIDTH = $clog2(NUM_ENTRIES);
	
 000753	input  uwire clk, res_n, rd, wr;
%000006	verilator_coverage: (next point on previous line)

 000024	verilator_coverage: (next point on previous line)

%000012	verilator_coverage: (next point on previous line)

%000290	input  uwire [DATA_WIDTH-1:0] wr_data;
%000111	input  uwire [ADDR_WIDTH-1:0] rd_addr, wr_addr;
%000062	verilator_coverage: (next point on previous line)

%000415	output uwire [DATA_WIDTH-1:0] rd_data;
	
	parameter ZERO_ADDR = {ADDR_WIDTH{1'b0}};
	parameter ZERO_DATA = {DATA_WIDTH{1'b0}};
	parameter ONE_DATA = {DATA_WIDTH{1'b1}};
	    
	logic    [DATA_WIDTH-1:0] MEMORY [NUM_ENTRIES-1:0];
	
	integer i;
	
%000008	initial begin
	   // Clear RAM before simulation start
%000004	   for ( i = 0; i < NUM_ENTRIES; i = i + 1 ) begin
 004096	   verilator_coverage: (next point on previous line)

 002048	       MEMORY[ i ] = ZERO_DATA;
	   end
	end
	
	// IN-CYCLE READ ACCESS
	assign rd_data =  ( rd & res_n ) ? MEMORY[rd_addr] : 'Z;
	
 001000	always_ff @ ( posedge clk ) begin
	    // WRITE ACCESS
 000984	   if( res_n ) begin
%000008	   verilator_coverage: (next point on previous line)

%000010	     if( wr ) MEMORY[wr_addr] <= wr_data;
 000487	     verilator_coverage: (next point on previous line)

%000008	   end else begin
%000008	     MEMORY <= '{default:'0};
	   end
	end
	
	endmodule
	
