// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Primary design header
//
// This header should be included by all source files instantiating the design.
// The class here is then constructed to instantiate the design.
// See the Verilator manual for examples.

#ifndef _VCACHE_H_
#define _VCACHE_H_  // guard

#include "verilated_heavy.h"
#include "verilated_cov.h"

//==========

class VCACHE__Syms;
class VCACHE_VerilatedVcd;
class VCACHE_RAM__D40_N200;


//----------

VL_MODULE(VCACHE) {
  public:
    // CELLS
    // Public to allow access to /*verilator_public*/ items;
    // otherwise the application code can consider these internals.
    VCACHE_RAM__D40_N200* __PVT__CACHE__DOT__B0_DAT_RAM;
    VCACHE_RAM__D40_N200* __PVT__CACHE__DOT__B1_DAT_RAM;
    
    // PORTS
    // The application code writes and reads these signals to
    // propagate new values into/out from the Verilated model.
    VL_IN8(clk,0,0);
    VL_IN8(res_n,0,0);
    VL_IN8(lock,0,0);
    VL_IN8(unlock,0,0);
    VL_IN8(phys_addr_in_vld,0,0);
    VL_IN8(data_from_mem_vld,0,0);
    VL_IN8(data_from_cpu_vld,0,0);
    VL_OUT8(data_to_cpu_vld,0,0);
    VL_OUT8(data_to_victim_buffer_vld,0,0);
    VL_OUT8(miss,0,0);
    VL_OUT8(locked,0,0);
    VL_IN(key,31,0);
    VL_IN64(phys_addr_in,39,0);
    VL_IN64(data_from_mem,63,0);
    VL_IN64(data_from_cpu,63,0);
    VL_OUT64(data_to_cpu,63,0);
    VL_OUT64(data_to_victim_buffer,63,0);
    
    // LOCAL SIGNALS
    // Internals; generally not touched by application code
    CData/*3:0*/ CACHE__DOT__STATE;
    CData/*3:0*/ CACHE__DOT__NEXT_STATE;
    CData/*0:0*/ CACHE__DOT__b0_tag_vld;
    CData/*0:0*/ CACHE__DOT__b1_tag_vld;
    CData/*0:0*/ CACHE__DOT__DO_IDLE_RD;
    CData/*0:0*/ CACHE__DOT__DO_IDLE_WR;
    CData/*0:0*/ CACHE__DOT__DO_LOCK;
    CData/*0:0*/ CACHE__DOT__DO_MEM_REQ;
    CData/*0:0*/ CACHE__DOT__DO_UNLOCK;
    CData/*0:0*/ CACHE__DOT__IS_HIT_B0;
    CData/*0:0*/ CACHE__DOT__IS_HIT_B1;
    CData/*0:0*/ CACHE__DOT__IS_MEM_REQ_DONE;
    CData/*0:0*/ CACHE__DOT__IS_RD_REQ;
    CData/*0:0*/ CACHE__DOT__IS_WR_REQ;
    CData/*0:0*/ CACHE__DOT__B0_DAT_RAM_rd;
    CData/*0:0*/ CACHE__DOT__B0_DAT_RAM_wr;
    CData/*0:0*/ CACHE__DOT__B0_TAG_RAM_rd;
    CData/*0:0*/ CACHE__DOT__B0_TAG_RAM_wr;
    CData/*0:0*/ CACHE__DOT__B1_DAT_RAM_rd;
    CData/*0:0*/ CACHE__DOT__B1_DAT_RAM_wr;
    CData/*0:0*/ CACHE__DOT__B1_TAG_RAM_rd;
    CData/*0:0*/ CACHE__DOT__B1_TAG_RAM_wr;
    SData/*8:0*/ CACHE__DOT__B0_DAT_RAM_rd_addr;
    SData/*8:0*/ CACHE__DOT__B0_DAT_RAM_wr_addr;
    SData/*8:0*/ CACHE__DOT__B0_TAG_RAM_rd_addr;
    SData/*8:0*/ CACHE__DOT__B0_TAG_RAM_wr_addr;
    SData/*8:0*/ CACHE__DOT__B1_DAT_RAM_rd_addr;
    SData/*8:0*/ CACHE__DOT__B1_DAT_RAM_wr_addr;
    SData/*8:0*/ CACHE__DOT__B1_TAG_RAM_rd_addr;
    SData/*8:0*/ CACHE__DOT__B1_TAG_RAM_wr_addr;
    IData/*24:0*/ CACHE__DOT__b0_tag;
    IData/*24:0*/ CACHE__DOT__b1_tag;
    IData/*25:0*/ CACHE__DOT__B0_TAG_RAM_rd_data;
    IData/*25:0*/ CACHE__DOT__B0_TAG_RAM_wr_data;
    IData/*25:0*/ CACHE__DOT__B1_TAG_RAM_rd_data;
    IData/*25:0*/ CACHE__DOT__B1_TAG_RAM_wr_data;
    IData/*31:0*/ CACHE__DOT__B0_TAG_RAM__DOT__i;
    IData/*31:0*/ CACHE__DOT__B1_TAG_RAM__DOT__i;
    QData/*63:0*/ CACHE__DOT__b0_dat;
    QData/*63:0*/ CACHE__DOT__b1_dat;
    QData/*63:0*/ CACHE__DOT__B0_DAT_RAM_rd_data;
    QData/*63:0*/ CACHE__DOT__B0_DAT_RAM_wr_data;
    QData/*63:0*/ CACHE__DOT__B1_DAT_RAM_rd_data;
    QData/*63:0*/ CACHE__DOT__B1_DAT_RAM_wr_data;
    IData/*25:0*/ CACHE__DOT__B0_TAG_RAM__DOT__MEMORY[512];
    IData/*25:0*/ CACHE__DOT__B1_TAG_RAM__DOT__MEMORY[512];
    
    // LOCAL VARIABLES
    // Internals; generally not touched by application code
    // Anonymous structures to workaround compiler member-count bugs
    struct {
        CData/*0:0*/ CACHE__DOT____Vtogcov__clk;
        CData/*0:0*/ CACHE__DOT____Vtogcov__res_n;
        CData/*0:0*/ CACHE__DOT____Vtogcov__lock;
        CData/*0:0*/ CACHE__DOT____Vtogcov__unlock;
        CData/*0:0*/ CACHE__DOT____Vtogcov__phys_addr_in_vld;
        CData/*0:0*/ CACHE__DOT____Vtogcov__data_from_mem_vld;
        CData/*0:0*/ CACHE__DOT____Vtogcov__data_from_cpu_vld;
        CData/*0:0*/ CACHE__DOT____Vtogcov__data_to_cpu_vld;
        CData/*0:0*/ CACHE__DOT____Vtogcov__data_to_victim_buffer_vld;
        CData/*0:0*/ CACHE__DOT____Vtogcov__miss;
        CData/*0:0*/ CACHE__DOT____Vtogcov__locked;
        CData/*3:0*/ CACHE__DOT____Vtogcov__STATE;
        CData/*3:0*/ CACHE__DOT____Vtogcov__NEXT_STATE;
        CData/*0:0*/ CACHE__DOT____Vtogcov__b0_tag_vld;
        CData/*0:0*/ CACHE__DOT____Vtogcov__b1_tag_vld;
        CData/*0:0*/ CACHE__DOT____Vtogcov__DO_ABORT;
        CData/*0:0*/ CACHE__DOT____Vtogcov__DO_IDLE_RD;
        CData/*0:0*/ CACHE__DOT____Vtogcov__DO_IDLE_WR;
        CData/*0:0*/ CACHE__DOT____Vtogcov__DO_LOCK;
        CData/*0:0*/ CACHE__DOT____Vtogcov__DO_MEM_REQ;
        CData/*0:0*/ CACHE__DOT____Vtogcov__DO_UNLOCK;
        CData/*0:0*/ CACHE__DOT____Vtogcov__IS_HIT_B0;
        CData/*0:0*/ CACHE__DOT____Vtogcov__IS_HIT_B1;
        CData/*0:0*/ CACHE__DOT____Vtogcov__IS_KEY_MATCH;
        CData/*0:0*/ CACHE__DOT____Vtogcov__IS_MEM_REQ_DONE;
        CData/*0:0*/ CACHE__DOT____Vtogcov__IS_RD_REQ;
        CData/*0:0*/ CACHE__DOT____Vtogcov__IS_WR_REQ;
        CData/*0:0*/ CACHE__DOT____Vtogcov__B0_DAT_RAM_rd;
        CData/*0:0*/ CACHE__DOT____Vtogcov__B0_DAT_RAM_wr;
        CData/*0:0*/ CACHE__DOT____Vtogcov__B0_TAG_RAM_rd;
        CData/*0:0*/ CACHE__DOT____Vtogcov__B0_TAG_RAM_wr;
        CData/*0:0*/ CACHE__DOT____Vtogcov__B1_DAT_RAM_rd;
        CData/*0:0*/ CACHE__DOT____Vtogcov__B1_DAT_RAM_wr;
        CData/*0:0*/ CACHE__DOT____Vtogcov__B1_TAG_RAM_rd;
        CData/*0:0*/ CACHE__DOT____Vtogcov__B1_TAG_RAM_wr;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__5__read;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__7__read;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__9__read;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__11__read;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__13__read;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B0_DAT_RAM__14__read;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__16__read;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B1_DAT_RAM__17__read;
        CData/*0:0*/ __Vtask_CACHE__DOT__PUSH_B0_DAT_RAM__18__write;
        CData/*0:0*/ __Vtask_CACHE__DOT__PUSH_B0_TAG_RAM__19__write;
        CData/*0:0*/ __Vtask_CACHE__DOT__PUSH_B1_DAT_RAM__20__write;
        CData/*0:0*/ __Vtask_CACHE__DOT__PUSH_B1_TAG_RAM__21__write;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B0_DAT_RAM__22__read;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B1_DAT_RAM__23__read;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__25__read;
        CData/*0:0*/ __Vtask_CACHE__DOT__PUSH_B0_DAT_RAM__26__write;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__28__read;
        CData/*0:0*/ __Vtask_CACHE__DOT__PUSH_B1_DAT_RAM__29__write;
        CData/*0:0*/ __Vtask_CACHE__DOT__PUSH_B0_DAT_RAM__30__write;
        CData/*0:0*/ __Vtask_CACHE__DOT__PUSH_B1_DAT_RAM__31__write;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B0_DAT_RAM__32__read;
        CData/*0:0*/ __Vfunc_CACHE__DOT__POP_B1_DAT_RAM__33__read;
        CData/*0:0*/ __Vclklast__TOP__clk;
        CData/*0:0*/ __Vchglast__TOP__CACHE__DOT__b0_tag_vld;
        CData/*0:0*/ __Vchglast__TOP__CACHE__DOT__b1_tag_vld;
        SData/*8:0*/ CACHE__DOT____Vtogcov__B0_DAT_RAM_rd_addr;
        SData/*8:0*/ CACHE__DOT____Vtogcov__B0_DAT_RAM_wr_addr;
        SData/*8:0*/ CACHE__DOT____Vtogcov__B0_TAG_RAM_rd_addr;
        SData/*8:0*/ CACHE__DOT____Vtogcov__B0_TAG_RAM_wr_addr;
    };
    struct {
        SData/*8:0*/ CACHE__DOT____Vtogcov__B1_DAT_RAM_rd_addr;
        SData/*8:0*/ CACHE__DOT____Vtogcov__B1_DAT_RAM_wr_addr;
        SData/*8:0*/ CACHE__DOT____Vtogcov__B1_TAG_RAM_rd_addr;
        SData/*8:0*/ CACHE__DOT____Vtogcov__B1_TAG_RAM_wr_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__5__read_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__7__read_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__9__read_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__11__read_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__13__read_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B0_DAT_RAM__14__read_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__16__read_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B1_DAT_RAM__17__read_addr;
        SData/*8:0*/ __Vtask_CACHE__DOT__PUSH_B0_DAT_RAM__18__write_addr;
        SData/*8:0*/ __Vtask_CACHE__DOT__PUSH_B0_TAG_RAM__19__write_addr;
        SData/*8:0*/ __Vtask_CACHE__DOT__PUSH_B1_DAT_RAM__20__write_addr;
        SData/*8:0*/ __Vtask_CACHE__DOT__PUSH_B1_TAG_RAM__21__write_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B0_DAT_RAM__22__read_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B1_DAT_RAM__23__read_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__25__read_addr;
        SData/*8:0*/ __Vtask_CACHE__DOT__PUSH_B0_DAT_RAM__26__write_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__28__read_addr;
        SData/*8:0*/ __Vtask_CACHE__DOT__PUSH_B1_DAT_RAM__29__write_addr;
        SData/*8:0*/ __Vtask_CACHE__DOT__PUSH_B0_DAT_RAM__30__write_addr;
        SData/*8:0*/ __Vtask_CACHE__DOT__PUSH_B1_DAT_RAM__31__write_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B0_DAT_RAM__32__read_addr;
        SData/*8:0*/ __Vfunc_CACHE__DOT__POP_B1_DAT_RAM__33__read_addr;
        IData/*31:0*/ CACHE__DOT____Vtogcov__key;
        IData/*24:0*/ CACHE__DOT____Vtogcov__b0_tag;
        IData/*24:0*/ CACHE__DOT____Vtogcov__b1_tag;
        IData/*25:0*/ CACHE__DOT____Vtogcov__B0_TAG_RAM_rd_data;
        IData/*25:0*/ CACHE__DOT____Vtogcov__B0_TAG_RAM_wr_data;
        IData/*25:0*/ CACHE__DOT____Vtogcov__B1_TAG_RAM_rd_data;
        IData/*25:0*/ CACHE__DOT____Vtogcov__B1_TAG_RAM_wr_data;
        IData/*25:0*/ CACHE__DOT__B0_TAG_RAM__DOT__rd_data__out__en0;
        IData/*25:0*/ CACHE__DOT__B1_TAG_RAM__DOT__rd_data__out__en0;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__4__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__5__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__6__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__7__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__8__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__9__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__10__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__11__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__12__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__13__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__15__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__16__Vfuncout;
        IData/*25:0*/ __Vtask_CACHE__DOT__PUSH_B0_TAG_RAM__19__write_data;
        IData/*25:0*/ __Vtask_CACHE__DOT__PUSH_B1_TAG_RAM__21__write_data;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__24__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B0_TAG_RAM__25__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__27__Vfuncout;
        IData/*25:0*/ __Vfunc_CACHE__DOT__POP_B1_TAG_RAM__28__Vfuncout;
        IData/*24:0*/ __Vchglast__TOP__CACHE__DOT__b0_tag;
        IData/*24:0*/ __Vchglast__TOP__CACHE__DOT__b1_tag;
        IData/*25:0*/ __Vchglast__TOP__CACHE__DOT__B0_TAG_RAM_rd_data;
        IData/*25:0*/ __Vchglast__TOP__CACHE__DOT__B1_TAG_RAM_rd_data;
        QData/*39:0*/ CACHE__DOT____Vtogcov__phys_addr_in;
        QData/*63:0*/ CACHE__DOT____Vtogcov__data_from_mem;
        QData/*63:0*/ CACHE__DOT____Vtogcov__data_from_cpu;
        QData/*63:0*/ CACHE__DOT____Vtogcov__data_to_cpu;
        QData/*63:0*/ CACHE__DOT____Vtogcov__data_to_victim_buffer;
        QData/*63:0*/ CACHE__DOT____Vtogcov__b0_dat;
        QData/*63:0*/ CACHE__DOT____Vtogcov__b1_dat;
    };
    struct {
        QData/*63:0*/ CACHE__DOT____Vtogcov__B0_DAT_RAM_rd_data;
        QData/*63:0*/ CACHE__DOT____Vtogcov__B0_DAT_RAM_wr_data;
        QData/*63:0*/ CACHE__DOT____Vtogcov__B1_DAT_RAM_rd_data;
        QData/*63:0*/ CACHE__DOT____Vtogcov__B1_DAT_RAM_wr_data;
        QData/*63:0*/ __Vfunc_CACHE__DOT__POP_B0_DAT_RAM__14__Vfuncout;
        QData/*63:0*/ __Vfunc_CACHE__DOT__POP_B1_DAT_RAM__17__Vfuncout;
        QData/*63:0*/ __Vtask_CACHE__DOT__PUSH_B0_DAT_RAM__18__write_data;
        QData/*63:0*/ __Vtask_CACHE__DOT__PUSH_B1_DAT_RAM__20__write_data;
        QData/*63:0*/ __Vfunc_CACHE__DOT__POP_B0_DAT_RAM__22__Vfuncout;
        QData/*63:0*/ __Vfunc_CACHE__DOT__POP_B1_DAT_RAM__23__Vfuncout;
        QData/*63:0*/ __Vtask_CACHE__DOT__PUSH_B0_DAT_RAM__26__write_data;
        QData/*63:0*/ __Vtask_CACHE__DOT__PUSH_B1_DAT_RAM__29__write_data;
        QData/*63:0*/ __Vtask_CACHE__DOT__PUSH_B0_DAT_RAM__30__write_data;
        QData/*63:0*/ __Vtask_CACHE__DOT__PUSH_B1_DAT_RAM__31__write_data;
        QData/*63:0*/ __Vfunc_CACHE__DOT__POP_B0_DAT_RAM__32__Vfuncout;
        QData/*63:0*/ __Vfunc_CACHE__DOT__POP_B1_DAT_RAM__33__Vfuncout;
        QData/*63:0*/ __Vchglast__TOP__CACHE__DOT__B0_DAT_RAM_rd_data;
        QData/*63:0*/ __Vchglast__TOP__CACHE__DOT__B1_DAT_RAM_rd_data;
        CData/*0:0*/ __Vm_traceActivity[2];
    };
    
    // INTERNAL VARIABLES
    // Internals; generally not touched by application code
    VCACHE__Syms* __VlSymsp;  // Symbol table
  private:
    // Coverage
    void __vlCoverInsert(uint32_t* countp, bool enable, const char* filenamep, int lineno, int column,
        const char* hierp, const char* pagep, const char* commentp, const char* linescovp);
  public:
    
    // CONSTRUCTORS
  private:
    VL_UNCOPYABLE(VCACHE);  ///< Copying not allowed
  public:
    /// Construct the model; called by application code
    /// The special name  may be used to make a wrapper with a
    /// single model invisible with respect to DPI scope names.
    VCACHE(const char* name = "TOP");
    /// Destroy the model; called (often implicitly) by application code
    ~VCACHE();
    /// Trace signals in the model; called by application code
    void trace(VerilatedVcdC* tfp, int levels, int options = 0);
    
    // API METHODS
    /// Evaluate the model.  Application must call when inputs change.
    void eval() { eval_step(); eval_end_step(); }
    /// Evaluate when calling multiple units/models per time step.
    void eval_step();
    /// Evaluate at end of a timestep for tracing, when using eval_step().
    /// Application must call after all eval() and before time changes.
    void eval_end_step();
    /// Simulation complete, run final blocks.  Application must call on completion.
    void final();
    
    // INTERNAL METHODS
  private:
    static void _eval_initial_loop(VCACHE__Syms* __restrict vlSymsp);
    void _traceDump();void _traceDumpOpen();void _traceDumpClose();public:
    void __Vconfigure(VCACHE__Syms* symsp, bool first);
  private:
    static QData _change_request(VCACHE__Syms* __restrict vlSymsp);
    static QData _change_request_1(VCACHE__Syms* __restrict vlSymsp);
  public:
    static void _combo__TOP__2(VCACHE__Syms* __restrict vlSymsp);
    static void _combo__TOP__6(VCACHE__Syms* __restrict vlSymsp);
  private:
    void _configure_coverage(VCACHE__Syms* __restrict vlSymsp, bool first) VL_ATTR_COLD;
    void _ctor_var_reset() VL_ATTR_COLD;
  public:
    static void _eval(VCACHE__Syms* __restrict vlSymsp);
  private:
#ifdef VL_DEBUG
    void _eval_debug_assertions();
#endif  // VL_DEBUG
  public:
    static void _eval_initial(VCACHE__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _eval_settle(VCACHE__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _initial__TOP__1(VCACHE__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _sequent__TOP__5(VCACHE__Syms* __restrict vlSymsp);
    static void _settle__TOP__3(VCACHE__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _settle__TOP__4(VCACHE__Syms* __restrict vlSymsp);
  private:
    static void traceChgSub0(void* userp, VerilatedVcd* tracep);
    static void traceChgTop0(void* userp, VerilatedVcd* tracep);
    static void traceCleanup(void* userp, VerilatedVcd* /*unused*/);
    static void traceFullSub0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceFullTop0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInitSub0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInitTop(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    void traceRegister(VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInit(void* userp, VerilatedVcd* tracep, uint32_t code) VL_ATTR_COLD;
} VL_ATTR_ALIGNED(VL_CACHE_LINE_BYTES);

//----------


#endif  // guard
